@echo off
color 0E

REM Output installation history to our log file
FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE/T') DO SET CDATE=%%B
FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE/T') DO SET mm=%%B
FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ('echo %CDATE%') DO SET dd=%%B
FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ('echo %CDATE%') DO SET yyyy=%%B
SET date=%mm%%dd%%yyyy%
echo %COMPUTERNAME% - %date% >> "\\<SharedFolderName>\installs\SophosVPN\install_history.txt"

CLS
echo.
echo *****Do not close this window during the installation*****
echo.
echo *****Installing Sophos VPN*****
echo *****This install could take several minutes*****


echo.
CLS
echo *****Do not close this window during the installation*****
echo Removing Cisco VPN...
msiexec /x {5FDC06BF-3D3D-4367-8FFB-4FAFCB61972D} /q

CLS
echo *****Do not close this window during the installation*****
echo.
echo Removing old Sophos VPN...

REM stop and uninstall existing sophos
taskkill /im openvpn-gui.exe /F >nul
net stop OpenVPNServiceInteractive >nul

CLS
echo *****Do not close this window during the installation*****
echo.
echo Removing old Sophos VPN...


REM Start the uninstaller
"C:\Program Files (x86)\Sophos\Sophos SSL VPN Client\Uninstall.exe" /S

REM Check if our uninstall is still going, if it is, keep looping.
:DoUntilLoop
tasklist /FI "IMAGENAME eq Au_.exe" 2>NUL | find /I /N "Au_.exe" >NUL
if "%ERRORLEVEL%"=="0" GOTO DoUntilLoop

REM Delete all Profiles
REM rmdir "C:\Program Files (x86)\Sophos" /S /Q

CLS
echo *****Do not close this window during the installation*****
echo.
echo Installing Sophos VPN...

"\\<SharedFolderName>\installs\SophosVPN\certmgr.exe" -add "\\<SharedFolderName>\installs\SophosVPN\sophos.cer" -c -s -r localMachine TrustedPublisher >nul
"\\<SharedFolderName>\installs\SophosVPN\setup.exe" /S

:DoUntilLoop2
tasklist /FI "IMAGENAME eq setup.exe" 2>NUL | find /I /N "setup.exe" >NUL
if "%ERRORLEVEL%"=="0" GOTO DoUntilLoop2

REM Copy a shortcut over because it usually doesn't copy itself
xcopy "\\<SharedFolderName>\installs\SophosVPN\Sophos" "%ALLUSERSPROFILE%\Microsoft\Windows\Start Menu\Programs\Sophos\" /y /e >nul

REM Remove the config for the users who created "setup.exe"
rmdir "%ProgramFiles(x86)%\Sophos\Sophos SSL VPN Client\config\<joelp@domainname.com>" /S /Q

REM Change permissions on the config folder so that users can install their on certificate
cacls "%ProgramFiles(x86)%\Sophos\Sophos SSL VPN Client\config" /t /e /g Everyone:f >nul

REM Kill our current VPN gui
taskkill /im openvpn-gui.exe /F >nul


REM Copy our new VPN GUI over
xcopy "\\<SharedFolderName>\installs\SophosVPN\openvpn-gui.exe" "C:\Program Files (x86)\Sophos\Sophos SSL VPN Client\bin" /y >nul

REM Display our success message.
CLS
echo.
echo.
echo ************************* Sophos VPN Installation *****************************
echo *                                                                             *
echo *  Sophos VPN has been sucessfully installed!                                 *
echo *                                                                             *
echo *******************************************************************************
echo.
echo The system will reboot in 20 seconds...
ping 127.0.0.1 -n 20 >nul
shutdown -r -t 00